'****************************************************************************
'
'  Module: secRMMSCCM_to_Syslog.vbs
'
'  Purpose: Send secRMM events from SCCM to Syslog.      
'
'  Copyright (c) 2021 Squadra Technologies 
'   
'****************************************************************************

SCCMSiteCode = "~~~SCCMSiteCode~~~"
LogFileName = "~~~LogFileName~~~"
' change the 4 Syslog variables to match your environment
Syslog_Server = "~~~SyslogServer~~~"
Syslog_Protocol = "~~~SyslogProtocol~~~"
Syslog_Port = "~~~SyslogPort~~~"
Syslog_MaxLength = "~~~SyslogMaxLength~~~"

Const ForAppending = 8
Set objFileSystemObject = CreateObject("Scripting.FileSystemObject")

' LogFileName = TargetEvent.ScriptFilename
' LogFileName = Replace(LogFileName, ".vbs", ".log")
Set LogFile = objFileSystemObject.OpenTextFile(LogFileName, ForAppending, True)

MachineName = TargetEvent.TargetInstance.MachineName
TheDateTime = CStr(TargetEvent.TargetInstance.Time)
EventId     = CStr(TargetEvent.TargetInstance.MessageID)
RecordId    = CStr(TargetEvent.TargetInstance.RecordID)

LogFile.WriteLine MachineName & " " & TheDateTime & " " & EventId & " " & RecordId

WMINamespace = "root\sms\site_" & SCCMSiteCode
WMIQuery = "select InsStrValue from SMS_StatInsStr where " & _
           "RecordId = " & RecordId
Set objLocator = CreateObject("WbemScripting.SWbemLocator")
Set objService = objLocator.ConnectServer(".", WMINamespace)
objService.Security_.ImpersonationLevel = 3
Set SMS_StatInsStrCol = objService.ExecQuery(WMIQuery)
InsStrValue = MachineName & ": "
For Each SMS_StatInsStr in SMS_StatInsStrCol
    InsStrValue = InsStrValue & SMS_StatInsStr.Properties_("InsStrValue")
Next

If (Len(InsStrValue) <> 0) Then
    LogFile.WriteLine "Got SCCM WMI record, sending via syslog."
    Dim SysLog
    Set SysLog = CreateObject("secRMMSendSyslog.dll")
    If IsObject(SysLog) Then
        Syslog_MessageText = InsStrValue
 
		Syslog_MessageLevel = "Information"
        Select case EventId 
			case "300"
				Syslog_MessageLevel = "Information"
			case "400"
				Syslog_MessageLevel = "Information"
			case "401"
				Syslog_MessageLevel = "Information"
			case "402"
				Syslog_MessageLevel = "Information"
			case "403"
				Syslog_MessageLevel = "Information"
			case "700"
				Syslog_MessageLevel = "Information"
			case "701"
				Syslog_MessageLevel = "Information"
			case "800"
				Syslog_MessageLevel = "Information"
			case "801"
				Syslog_MessageLevel = "Information"
			case "802"
				Syslog_MessageLevel = "Information"
			case "805"
				Syslog_MessageLevel = "Information"
			case "806"
				Syslog_MessageLevel = "Information"
			case "807"
				Syslog_MessageLevel = "Information"
			case "808"
				Syslog_MessageLevel = "Information"
			case "809"
				Syslog_MessageLevel = "Information"
			case "600"
				Syslog_MessageLevel = "Warning"
			case "500"
				Syslog_MessageLevel = "Error"
			case "501"
				Syslog_MessageLevel = "Error"
			case "502"
				Syslog_MessageLevel = "Error"
			case "503"
				Syslog_MessageLevel = "Error"
			case "504"
				Syslog_MessageLevel = "Error"
			case "505"
				Syslog_MessageLevel = "Error"
			case "506"
				Syslog_MessageLevel = "Error"
			case "507"
				Syslog_MessageLevel = "Error"
			case "508"
				Syslog_MessageLevel = "Error"
			case "509"
				Syslog_MessageLevel = "Error"
			case "510"
				Syslog_MessageLevel = "Error"
			case "511"
				Syslog_MessageLevel = "Error"
			case "512"
				Syslog_MessageLevel = "Error"
			case "513"
				Syslog_MessageLevel = "Error"
			case "514"
				Syslog_MessageLevel = "Error"
			case "515"
				Syslog_MessageLevel = "Error"
			case "601"
				Syslog_MessageLevel = "Error"
			case "803"
				Syslog_MessageLevel = "Error"
			case "804"
				Syslog_MessageLevel = "Error"
			case "810"
				Syslog_MessageLevel = "Error"
			case "811"
				Syslog_MessageLevel = "Error"
			case "812"
				Syslog_MessageLevel = "Error"
			case "813"
				Syslog_MessageLevel = "Error"
		End Select

        result = SysLog.SendSyslog( _
            Syslog_Server, _
            Syslog_Protocol, _ 
            Syslog_Port, _
            Syslog_MaxLength, _
            Syslog_MessageLevel, _
            Syslog_MessageText)

        LogFile.WriteLine Syslog_MessageText
        Set SysLog = Nothing
    End If
Else
    LogFile.WriteLine "ERROR: did not get SCCM WMI record."
End If

LogFile.Close
